package com.jiuqi.script;

import java.util.HashMap;
import java.util.ArrayList;
import java.util.Map;
import java.util.List;

public class ScriptManager
{
    private static List factoryList;
    private static Map factoryMap;
    
    static {
        ScriptManager.factoryList = new ArrayList();
        ScriptManager.factoryMap = new HashMap();
        try {
            Class.forName("com.jiuqi.script.rhino.RhinoScript");
        }
        catch (final ClassNotFoundException ex) {}
    }
    
    private ScriptManager() {
    }
    
    public static Script getScript(final String name) throws ScriptException {
        final ScriptFactory factory = ScriptManager.factoryMap.get(name);
        if (factory == null) {
            throw new ScriptException("未注册名为" + name + "的脚本引擎");
        }
        return factory.createScript();
    }
    
    public static void registerScriptFactory(final ScriptFactory scriptFactory) {
        ScriptManager.factoryList.add(scriptFactory);
        final String[] names = scriptFactory.getNames();
        for (int i = 0; i < names.length; ++i) {
            ScriptManager.factoryMap.put(names[i], scriptFactory);
        }
    }
    
    public static ScriptFactory[] getScriptFactories() {
        return ScriptManager.factoryList.toArray(new ScriptFactory[0]);
    }
}
